/*
Hebcal Widget, version 1.0 051010
for Mac OS X 10.4 and later

Portions of this code are Copyright (c) 2005 Mark A. Saper (hebcal@comcast.net).
Data kindly provided by 1-Click Shabbat (http://hebcal.com), Copyright 2005 Michael J. Radwin, and
hebcal 3.4 for Unix (http://sourceforge.net/projects/hebcal/), Copyright 2005, David Sadinoff. All rights reserved.

Portions of this code Copyright (c) 2005, Apple Computer, Inc.  All rights reserved.
NOTE:  Use of this source code is subject to the terms of the Software
License Agreement for Mac OS X, which accompanies the code.  Your use
of this source code signifies your agreement to such license terms and
conditions.  Except as expressly granted in the Software License Agreement
for Mac OS X, no other copyright, patent, or other intellectual property
license or right is granted, either expressly or by implication, by Apple.
*/

/***********************************/
// SAVING AND RETRIEVING PREFERENCES
/***********************************/

// setup() is run when the body loads.  It checks to see if there is a preference for this widget
// and if so, applies the preference to the widget.

var	timer = null;
var theDate = new Date();
var updateTime = theDate.getTime();
var zip = '';
var minHavdalah = '';
var inputValidated = false;

function setup()
{
	if(window.widget)		// always check to make sure that you are running in Dashboard
	{
		//document.getElementById('debugDiv').innerHTML = 'in setup()'

		// Retrieve Preferences

		zip = widget.preferenceForKey("zip");
		
		if (zip && zip.length > 0)  // if the retrieved preferences are not empty,
		{											// they are restored.
			document.getElementById("zip").value = zip;
		}
		else						// otherwise store current or default values
		{	
			zip = document.getElementById("zip").value;
			if (zip.length = 0)
			then
			{
				zip = '48104';
			}
			widget.setPreferenceForKey(zip, "zip");
		}


		minHavdalah = widget.preferenceForKey("minHavdalah");

		if (minHavdalah && minHavdalah.length > 0)  // if the retrieved preferences are not empty,
		{											// they are restored.
			document.getElementById("minHavdalah").value = minHavdalah;
		}
		else
		{	
			minHavdalah = document.getElementById("minHavdalah").value;
			widget.setPreferenceForKey(minHavdalah, "minHavdalah");
		}
		inputValidated = true;
	}

//  Setup Event Handlers
	widget.onshow = onshow;
	widget.onhide = onhide;

//  DISPLAY FRONT  ??
	var front = document.getElementById('front');
	front.style.display= 'block';		// show the front

	onshow();
//	updateTime = theDate.getTime();
	
}

function onhide () {
    if (timer != null) {
        clearInterval(timer);
        timer = null;
    }
}

function onshow () {

//	document.getElementById('debugDiv').innerHTML = front.style.display

//	Make sure we are looking at the front before updating.
	var front = document.getElementById('front');
	if (front.style.display == 'block') {
		update();
	}
//		back.style.display = 'none';
//		front.style.display = 'block';		// show the front
		

}

function update()
{
//	document.getElementById('debugDiv').innerHTML = 'in update()'

	if (window.widget)		// always check to make sure that you are running in Dashboard
	{

		widget.system( "./gethebcal.sh " + zip + " " + minHavdalah, null);

//	OPEN UP THE WINDOW	
		window.resizeTo( 600, 200);
			
//	GET THE CONTENT
		document.getElementById('content').innerHTML = '';
		var output = readIn("FINAL.html");
		document.getElementById('content').innerHTML = output;

//  GET THE ACTUAL WIDTH OF THE HEBCAL CONTENT AND ADJUST WINDOW
//		SHOULD CHECK THAT IT IS AT LEAST A CERTAIN SIZE.
		var hebcal = document.getElementById('hebcal');
		hebcal_width = document.defaultView.getComputedStyle(hebcal, '').getPropertyValue("width");
		hebcal_height = document.defaultView.getComputedStyle(hebcal, '').getPropertyValue("height");

//	document.getElementById('debugDiv').innerHTML = String(hebcal_height) + String(hebcal_width);
 
		if (hebcal_width < 288) hebcal_width = 288;
		if (hebcal_height < 75) hebcal_height = 75;

		var newWidth = parseInt(hebcal_width) + 40;
		
		var newHeight = parseInt(hebcal_height) + 40;
		window.resizeTo(newWidth, newHeight);

//	CHANGE SIZE OF BACKGROUND IMAGES (SETTING SIZE TO AUTO IN
//		CSS MIGHT TAKE THE PLACE OF THIS
		var frontBgrnd = document.getElementById("frontBgrnd");
		frontBgrnd.style.width = 	String( newWidth + 10) + "px";
		frontBgrnd.style.height = 	String( newHeight) + "px";

		var backBgrnd = document.getElementById("backBgrnd");
		backBgrnd.style.width = 	frontBgrnd.style.width;
		backBgrnd.style.height = 	frontBgrnd.style.height;

	}
}


/*********************************/
// HIDING AND SHOWING REVERSE SIDE
/*********************************/

// showPrefs() is called when the preferences flipper is clicked upon.  It freezes the front of the widget,
// hides the front div, unhides the back div, and then flips the widget over.

function showPrefs()
{
	var front = document.getElementById("front");
	var back = document.getElementById("back");
	
	if (window.widget)
		widget.prepareForTransition("ToBack");		// freezes the widget so that you can change it without the user noticing
	
	front.style.display="none";		// hide the front
	back.style.display="block";		// show the back
	
	if (window.widget)
		setTimeout ('widget.performTransition();', 0);		// and flip the widget over	

	document.getElementById('fliprollie').style.display = 'none';  // clean up the front side - hide the circle behind the info button

}


// hidePrefs() is called by the done button on the back side of the widget.  It performs the
// opposite transition as showPrefs() does.

function hidePrefs()
{
	var front = document.getElementById("front");
	var back = document.getElementById("back");

	if( !inputValidated )				// Check if the input has changed.
	{
		minHavdalah = document.getElementById("minHavdalah").value;
		widget.setPreferenceForKey(minHavdalah, "minHavdalah");

		zip = document.getElementById("zip").value;
		widget.setPreferenceForKey(zip, "zip");

		inputValidated = true;
	}

	
	if (window.widget)
		widget.prepareForTransition("ToFront");		// freezes the widget and prepares it for the flip back to the front
	
	back.style.display="none";			// hide the back
	front.style.display="block";		// show the front

	
	if (window.widget)
		setTimeout ("widget.performTransition();", 0);		// and flip the widget back to the front

    timer = setTimeout("update();", 1 * 1000);
	
//	document.getElementById("doneButton") = "Images/done.png";   // reset button to unpressed.

}


// PREFERENCE BUTTON ANIMATION (- the pref flipper fade in/out)

var flipShown = false;		// a flag used to signify if the flipper is currently shown or not.

// A structure that holds information that is needed for the animation to run.
var animation = {duration:0, starttime:0, to:1.0, now:0.0, from:0.0, firstElement:null, timer:null};

// mousemove() is the event handle assigned to the onmousemove property on the front div of the widget. 
// It is triggered whenever a mouse is moved within the bounds of your widget.  It prepares the
// preference flipper fade and then calls animate() to performs the animation.

function mousemove (event)
{
	if (!flipShown)			// if the preferences flipper is not already showing...
	{
		if (animation.timer != null)			// reset the animation timer value, in case a value was left behind
		{
			clearInterval (animation.timer);
			animation.timer  = null;
		}
		
		var starttime = (new Date).getTime() - 13; 		// set it back one frame
		
		animation.duration = 500;												// animation time, in ms
		animation.starttime = starttime;										// specify the start time
		animation.firstElement = document.getElementById ('flip');		// specify the element to fade
		animation.timer = setInterval ("animate();", 13);						// set the animation function
		animation.from = animation.now;											// beginning opacity (not ness. 0)
		animation.to = 1.0;														// final opacity
		animate();																// begin animation
		flipShown = true;														// mark the flipper as animated
	}
}

// mouseexit() is the opposite of mousemove() in that it preps the preferences flipper
// to disappear.  It adds the appropriate values to the animation data structure and sets the animation in motion.

function mouseexit (event)
{
	if (flipShown)
	{
		// fade in the flip widget
		if (animation.timer != null)
		{
			clearInterval (animation.timer);
			animation.timer  = null;
		}
		
		var starttime = (new Date).getTime() - 13;
		
		animation.duration = 500;
		animation.starttime = starttime;
		animation.firstElement = document.getElementById ('flip');
		animation.timer = setInterval ("animate();", 13);
		animation.from = animation.now;
		animation.to = 0.0;
		animate();
		flipShown = false;
	}
}


// animate() performs the fade animation for the preferences flipper. It uses the opacity CSS property to simulate a fade.

function animate()
{
	var T;
	var ease;
	var time = (new Date).getTime();
		
	
	T = limit_3(time-animation.starttime, 0, animation.duration);
	
	if (T >= animation.duration)
	{
		clearInterval (animation.timer);
		animation.timer = null;
		animation.now = animation.to;
	}
	else
	{
		ease = 0.5 - (0.5 * Math.cos(Math.PI * T / animation.duration));
		animation.now = computeNextFloat (animation.from, animation.to, ease);
	}
	
	animation.firstElement.style.opacity = animation.now;
}


// these functions are utilities used by animate()

function limit_3 (a, b, c)
{
    return a < b ? b : (a > c ? c : a);
}

function computeNextFloat (from, to, ease)
{
    return from + (to - from) * ease;
}

// these functions are called when the info button itself receives onmouseover and onmouseout events

function enterflip(event)
{
	document.getElementById('fliprollie').style.display = 'block';
}

function exitflip(event)
{
	document.getElementById('fliprollie').style.display = 'none';
}

function readIn(filename) {
    req = new XMLHttpRequest();
    req.open("GET", filename ,false);
    req.send(null);
    response = req.responseText;
    if (response)
        return response;
    return "";
}

function zipTyping (event)
{
	inputValidated = false;
}

function zipKeyPress (event)
{
	switch (event.keyCode)
	{
		case 13: // return
		case 3:  // enter
			hidePrefs();
			break;
	}
}

function minHavdalahTyping (event)
{
	inputValidated = false;

}

function minHavdalahKeyPress (event)
{
	switch (event.keyCode)
	{
		case 13: // return
		case 3:  // enter
			hidePrefs();
			break;
	}
}

function getURL(  )
{
	return 'http://www.hebcal.com/shabbat/?geo=zip;zip=' + zip + ';m=' + minHavdalah + ';tag=js.1c'
}
